unit MastappQueryFrm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  MastappFrm, OleanderWord8, OleanderAuto, OleanderPrinter, OleanderWord7,
  OleanderController, StdCtrls, Grids, DBGrids, DBCtrls, ExtCtrls, Buttons,
  ComCtrls, DB, DBTables, OleanderIdentifier;

type
  TfrmMastappQuery = class(TfrmMastapp)
    qryCustomerList: TQuery;
    qryOrderHistory: TQuery;
    qryInvoice: TQuery;
    qryInvoiceorderno: TFloatField;
    qryInvoicecustno: TFloatField;
    qryInvoicesaledate: TDateTimeField;
    qryInvoiceShipdate: TDateTimeField;
    qryInvoiceShipVia: TStringField;
    qryInvoiceItemsTotal: TCurrencyField;
    qryInvoiceFreight: TCurrencyField;
    qryInvoicecompany: TStringField;
    qryInvoiceAddr1: TStringField;
    qryInvoiceAddr2: TStringField;
    qryInvoiceCity: TStringField;
    qryInvoiceCountry: TStringField;
    qryInvoiceFirstName: TStringField;
    qryInvoiceLastName: TStringField;
    qryInvoicepartno: TFloatField;
    qryInvoiceqty: TIntegerField;
    qryInvoicediscount: TFloatField;
    qryInvoicedescription: TStringField;
    qryInvoiceListprice: TCurrencyField;
    qryInvoicecalExtendedPrice: TCurrencyField;
    qryInvoicecalTotal: TCurrencyField;
    dscCustomerList: TDataSource;
    dscOrderHistory: TDataSource;
    dscInvoice: TDataSource;
    lblFromdate: TLabel;
    edtFromDate: TEdit;
    lblToDate: TLabel;
    edtToDate: TEdit;
    procedure olcControllerIdentifierCheck(Sender: TObject;
      const AIdentifier: TOleanderIdentifier; var AOk: Boolean);
    procedure olcControllerIdentifierValue(Sender: TObject;
      const AIdentifier: TOleanderIdentifier; var AValue: string);
    procedure edtFromToDateExit(Sender: TObject);
    procedure btnStartClick(Sender: TObject);
    procedure qryInvoiceCalcFields(DataSet: TDataSet);
    procedure cbxDocumentChange(Sender: TObject);
  private
    procedure SetupHistory;
  public
  end;

implementation

{$R *.DFM}

const
  IDFROMDATE      = 'FROMDATE';
  IDTODATE        = 'TODATE';

procedure TfrmMastappQuery.SetupHistory;
var
  fd, td : TDateTime;
begin
  try
    fd := StrToDate(edtFromDate.Text);
    td := StrToDate(edtToDate.Text);
    if (fd > td) or (td = 0) then
      Raise EConvertError.Create('');
  except
    on EConvertError do
    begin
      fd := 0;
      td := Now;
    end;
  end;
  qryOrderHistory.ParamByName(IDFROMDATE).AsDateTime := fd;
  qryOrderHistory.ParamByName(IDTODATE).AsDateTime := td;
  if qryOrderHistory.Active then
  begin
    qryOrderHistory.Close;
    qryOrderHistory.Open;
  end;
end;

procedure TfrmMastappQuery.olcControllerIdentifierCheck(Sender: TObject;
  const AIdentifier: TOleanderIdentifier; var AOk: Boolean);
begin
  inherited;
  if (AIdentifier.Name = IDFROMDATE) or (AIdentifier.Name = IDTODATE) then
  begin
    AOk := TRUE;
    AIdentifier.DataType := ftDate;
  end;
end;

procedure TfrmMastappQuery.olcControllerIdentifierValue(Sender: TObject;
  const AIdentifier: TOleanderIdentifier; var AValue: string);
begin
  inherited;
  if AIdentifier.Name = IDFROMDATE then AValue := edtFromDate.Text
  else if AIdentifier.Name = IDTODATE then AValue := edtToDate.Text;
end;

procedure TfrmMastappQuery.edtFromToDateExit(Sender: TObject);
begin
  inherited;
  if (sender is TEdit) and (TEdit(sender).Text <> '') then
  try
    StrToDate(TEdit(sender).Text);
    if (sender = edtFromDate) and (edtToDate.Text = '') then edtToDate.Text := edtFromDate.Text;
    if StrToDate(edtFromDate.Text) > StrToDate(edtToDate.Text) then
      Raise EConvertError.Create('"To" date prior to "From" date!');
    SetUpHistory;
  except
    on e: EConvertError do
    begin
      MessageDlg(e.message, mtError, [mbOk], 0);
      TEdit(sender).Text := '';
      TEdit(sender).SetFocus;
    end;
  end;
end;

procedure TfrmMastappQuery.btnStartClick(Sender: TObject);
begin
  SetupHistory;
  inherited;
end;

procedure TfrmMastappQuery.qryInvoiceCalcFields(DataSet: TDataSet);
begin
  inherited;
  qryInvoicecalExtendedPrice.AsFloat := qryInvoiceQty.AsInteger * qryInvoiceListPrice.AsFloat;
  qryInvoicecalTotal.AsFloat := qryInvoiceItemsTotal.AsFloat + qryInvoiceFreight.AsFloat;
end;

procedure TfrmMastappQuery.cbxDocumentChange(Sender: TObject);
begin
  olcController.Close;
  qryCustomerList.Close;
  qryOrderHistory.Close;
  qryInvoice.Close;
  lblFromDate.Enabled := FALSE;
  lblToDate.Enabled := FALSE;
  edtFromDate.Enabled := FALSE;
  edtToDate.Enabled := FALSE;
  case cbxDocument.ItemIndex of
    repCustomerList : begin
                        qryCustomerList.Open;
                        olcController.Datasource := dscCustomerList;
                      end;
    repOrderHistory : begin
                        SetupHistory;
                        qryOrderHistory.Open;
                        olcController.Datasource := dscOrderHistory;
                        lblFromDate.Enabled := TRUE;
                        lblToDate.Enabled := TRUE;
                        edtFromDate.Enabled := TRUE;
                        edtToDate.Enabled := TRUE;
                      end;
    repInvoice      : begin
                        qryInvoice.Open;
                        olcController.Datasource := dscInvoice;
                      end;
  end;
  oleserver.DocName := 'Mastapp ' + cbxDocument.Items[cbxDocument.itemindex] + ' (TQUERY).doc';
  dbgDemo.Datasource := olcController.Datasource;
  dbnDemo.Datasource := olcController.Datasource;
  inherited;
end;

end.
